/*  UNDEAD TERROR
 *  OSK.c
 *  
 *
 *  Created by FlavR & Leo.
 *  Copyright 2010. All rights reserved.
 *
 */

#include <pspkernel.h>
#include <pspdisplay.h>
#include <pspdebug.h>
#include <pspgu.h>
#include <string.h>
#include <stdio.h>
#include <psputility.h>
#include <malloc.h>
#include <math.h>

#include <libge/libge.h>

#include "OSK.h"

#define MAX_CHAR 64

void createOsk(SceUtilityOskData *data, unsigned short *input, unsigned short *desc)
{		
	unsigned short outtext[128] = { 0 };
	memset(data, 0, sizeof(SceUtilityOskData));
	data->language = PSP_UTILITY_OSK_LANGUAGE_DEFAULT;
	data->lines = 2;
	data->unk_24 = 1;
	data->inputtype = PSP_UTILITY_OSK_INPUTTYPE_ALL;
	data->desc = desc;
	data->intext = input;
	data->outtextlength = MAX_CHAR;
	data->outtextlimit = 64;
	data->outtext = outtext;
	
	SceUtilityOskParams params;
	memset(&params, 0, sizeof(params));
	params.base.size = sizeof(params);
	sceUtilityGetSystemParamInt(PSP_SYSTEMPARAM_ID_INT_LANGUAGE, &params.base.language);
	sceUtilityGetSystemParamInt(PSP_SYSTEMPARAM_ID_INT_UNKNOWN, &params.base.buttonSwap);
	params.base.graphicsThread = 17;
	params.base.accessThread = 19;
	params.base.fontThread = 18;
	params.base.soundThread = 16;
	params.datacount = 1;
	params.data = data;
	
	
	sceUtilityOskInitStart(&params);
}


void charShort(const char *in, unsigned short *out)
{
	int i;
	
	for (i = 0; i < strlen(in); i++)
		out[i] = in[i];
	
	out[strlen(in)] = 0;
}

char *startOSK(const char *textinput, const char *description)
{	
	unsigned short* intext = memalign(16, sizeof(unsigned short)*(strlen(textinput+1)));
	charShort(textinput, intext);
	unsigned short* desc = memalign(16, sizeof(unsigned short)*(strlen(description)+1));
	charShort(description, desc);
	
	int i, done = 0;
	
	SceUtilityOskData data;
	createOsk(&data, intext, desc);
	
	while(!done)
	{
		//geClearScreen();//0xFF808080
		//geFillRectScreen(0,0, 480, 272, RGB(0,0,0));
		
		switch(sceUtilityOskGetStatus())
		{
			case PSP_UTILITY_DIALOG_INIT:
				break;
				
			case PSP_UTILITY_DIALOG_VISIBLE:
				sceUtilityOskUpdate(1);
				break;
				
			case PSP_UTILITY_DIALOG_QUIT:
				sceUtilityOskShutdownStart();
				break;
				
			case PSP_UTILITY_DIALOG_FINISHED:
				break;
				
			case PSP_UTILITY_DIALOG_NONE:
				done = 1;
				break;
				
			default :
				break;
		}
		
		sceDisplayWaitVblankStart();
		geSwapBuffers();
	}
	
	char *outtext = (char*) memalign(16, data.outtextlength*sizeof(char)+1);
	
	for (i = 0; i < data.outtextlength; ++i)
		outtext[i] = data.outtext[i];
	
	free(desc);
	free(outtext);
	free(intext);
	
	return outtext;
}

//EOF
