/*  UNDEAD TERROR
 *  armes.c
 *  
 *
 *  Created by FlavR & Leo.
 *  Copyright 2010. All rights reserved.
 *
 */

#include <libge/libge.h>
#include <math.h> //cos and sin

#include "functions.h"
#include "armes.h"


//Creates a bullet
Balle creerTir(float angle, int L, int a, int EPAULE_X, int EPAULE_Y)
{
	Balle tir;
	
	tir.x = EPAULE_X + L * cos(deg2rad(angle + a)); //Positions of the wepon's end
	tir.y = EPAULE_Y - L * sin(deg2rad(angle + a)); //Positions of the wepon's end
	
	tir.avX = cos(deg2rad(angle)) * 8; //The distance of a bullet in 1 loop
	tir.avY = sin(deg2rad(angle)) * 8; //The distance of a bullet in 1 loop
	
	tir.angle = angle;
	
	tir.isVisible = true;
	
	return tir;
}

//Loads a weapon
Weapon initWeapon(char* name, char *image, int capacity, int type, int reloadTime, int damage, int L, int a, float t)
{
	Weapon temp;
	
	temp.name = name;
	temp.magazineCapacity = capacity;
	temp.magazineUsedContent = 0;
	
	temp.type = type;
	
	temp.damage = damage;
	
	temp.reloadTime = reloadTime;
	temp.reloadSleep = 0;
	
	temp.L = L;
	temp.a = a;
	temp.t = t;
	
	temp.img = geLoadImage(image);
	
	return temp;
}

//Change a weapon (pressing triangle in the game)
int ChangeWeapon(int a)
{
	return a < 3 ? a+1 : 0;
}

//Free a weapon
void freeWeapon(Weapon w)
{
	geFree(w.img->data);
	geFree(w.img);
}


//EOF

