/*  UNDEAD TERROR
 *  cine.c
 *  
 *
 *  Created by FlavR & Leo.
 *  Copyright 2010. All rights reserved.
 *
 */

#include <libge/libge.h>
#include <stdlib.h>

#include "cine.h"
#include "functions.h"

info nextImage(FILE* images)
{
	info temp;
	char time[15];
	fgets( temp.path, 100, images);//On lit le path
	supprRC( temp.path);//On retire le caractere retour a la ligne
	fgets( time, 100, images); // on lit la duree
	supprRC( time); //On retire le caractere retour a la ligne
	temp.duration = atoi(time);//On convertit
	return temp;
}

void afficherCinematique(const char *path)
{

	char cineTemp[45];
	
	sprintf(cineTemp, "%s/cinematique.txt", path);
	FILE* images = fopen(cineTemp, "r");
	if (!images) return;
	
	int frames, number, i;
	u32 oldtime = 0;
	
	char temp[10];
	ge_Image *CurrentImage;
	ge_Timer *timer = geCreateTimer("timer");
	fgets(temp, 10, images);//On recupere le nombre d'images
	
	supprRC(temp); //On retire le caractere retour a la ligne
	number = atoi(temp);
	
	int move; //0: no; 1: x; 2: y;
	double x, y, step;
	
	info *infos;
	infos = geMalloc(number * sizeof(info));

	for (i = 0; i < number; i++)
	{
		infos[i] = nextImage(images);
	}
	
	fclose(images);
	
	for (i = 0; i < number; i++)
	{
		sprintf(cineTemp, "%s/%s", path, infos[i].path);
		CurrentImage = geLoadImage(cineTemp);
		
		frames = infos[i].duration / 1000000 * 12;
		
		step = 0;
		move = 0;
		
		
		if (CurrentImage->width > 480)
		{
			step = (CurrentImage->width - 480) / frames;
			move = 1;
		}
		
		if((CurrentImage->height > 272) && (move == 0))
		{
			step = (CurrentImage->height - 272) / frames;
			move = 2;
		}
			
		x = 0, y = 0;
		
		geStartTimer(timer);
		
		while (timer->ellapsed < infos[i].duration)
		{
			if (timer->ellapsed - oldtime >= infos[i].duration / frames)
			{
				switch (move)
				{
					case 1: x -= step; break;
					case 2: y -= step; break;
				}
				oldtime = timer->ellapsed;
			}
			
			geClearScreen();
			geDrawImage(x,y, CurrentImage);
			
			sceDisplayWaitVblankStart();
			geSwapBuffers();
			
			geUpdateTimer(timer);
		}
		
		geFreeImage(CurrentImage);
		geResetTimer(timer);
	}
	geFree(infos);
}

//EOF
