/*  UNDEAD TERROR
 *  danzeff.c
 *  
 *
 *  Created by FlavR & Leo.
 *  Copyright 2010. All rights reserved.
 *
 */

#include <libge/libge.h>

#include "functions.h"
#include "gui.h"
#include "danzeff.h"

//All characters
char clavier [2] [3] [3] [4] [3] = {
	{{ {",","a","b","c"}, {".","d","e","f"}, {"!","g","h","i"} },
	{ {"-","j","k","l"}, {"de","m"," ", "n"}, {"?","o","p","q"} },
	{ {"(","r","s","t"}, {":","u","v","w"}, {")","x","y","z"} }},
	
	//{{ {"^","A","B","C"}, {"@","D","E","F"}, {"*","G","H","I"} },
	//{ {"_","J","K","L"}, {"de","M"," ", "N"}, {"\"","O","P","Q"}},
	//{ {"=","R","S","T"}, {";","U","V","W"}, {"/","X","Y","Z"} }},
	
	{{ {"", "", "", "1"}, {"", "", "", "2"}, {"", "", "", "3"} },
	{ {"", "", "", "4"}, {"de", "", " ","5"}, {"", "", "", "6"}},
	{ {"", "", "", "7"}, {"", "", "", "8"}, {"", "", "0", "9"} }},
	
	//{{ {",","(",".",")"}, {"\"","<","'",">"}, {"-","[","_","]"} },
	//{ {"!","{","?","}"}, {"de", "", " ",""}, {"+","\\","=","/"}},
	//{ {":","@",";","#"}, {"~","$","","%"}, {"*","^","|","&"} }}
};

//All images
char *clavierImages[4] = {
	"Images/Danzeff/keys.png", "Images/Danzeff/keys_t.png",
	"Images/Danzeff/nums.png", "Images/Danzeff/nums_t.png",
};

danzeffSelector getJoystick(SceCtrlData pad)
{
	danzeffSelector selector = {1,1};
	
	if ((pad.Lx < 68) && (pad.Ly < 68)) //Up left
	{
		selector.x = 0;
		selector.y = 0;
	}
	else if ((pad.Lx > 68) && (pad.Lx < 188) && (pad.Ly < 68)) //Up middle
	{
		selector.x = 1;
		selector.y = 0;
	}
	else if ((pad.Lx > 188) && (pad.Ly < 68)) //Up right
	{
		selector.x = 2;
		selector.y = 0;
	}
	else if ((pad.Lx < 68) && (pad.Ly > 68) && (pad.Ly < 188)) //Middle left
	{
		selector.x = 0;
		selector.y = 1;
	}
	else if ((pad.Lx > 68) && (pad.Lx < 188) && (pad.Ly > 68) && (pad.Ly < 188)) //Middle
	{
		selector.x = 1;
		selector.y = 1;
	}
	else if ((pad.Lx > 188) && (pad.Ly > 68) && (pad.Ly < 188)) //Middle Right
	{
		selector.x = 2;
		selector.y = 1;
	}
	else if ((pad.Lx < 68) && (pad.Ly > 188)) //Bottom left
	{
		selector.x = 0;
		selector.y = 2;
	}
	else if ((pad.Lx > 68) && (pad.Lx < 188) && (pad.Ly > 188)) //Bottom middle
	{
		selector.x = 1;
		selector.y = 2;
	}
	else if ((pad.Lx > 188) && (pad.Ly > 188)) //Bottom right
	{
		selector.x = 2;
		selector.y = 2;
	}
	
	return selector; //Return selector positions
}

bool initialised = false;
ge_Image *keys[2][2];
char input[MAX_CHAR];

char *startDanzeff(ge_Font *font, char *intext, char *desc, ge_Image*bg)
{
	//pspDebugScreenPrintf("point1");
	if (!initialised)
	{
		keys[0][0] = geLoadImage(clavierImages[0]);		
		keys[0][1] = geLoadImage(clavierImages[1]);
		
		keys[1][0] = geLoadImage(clavierImages[2]);
		keys[1][1] = geLoadImage(clavierImages[3]);
		
		initialised = true;
	}
	
	SceCtrlData pad, oldpad;
	sceCtrlPeekBufferPositive(&oldpad, 1);
	
	int isNUMBER = 0;
	
	danzeffSelector selector = getJoystick(pad);
	
	int done = 0;
	
	strncpy(input, intext, MAX_CHAR);
	
	while (!done)
	{
		geClearScreen();
		geDrawImage(0,0, bg);
		sceCtrlReadBufferPositive(&pad, 1);
		
		geIntraFontPrintScreenBordered(10, 65, font, input, RGBA(255,128,0,225), RGB(255,255,255));
		geIntraFontPrintScreen(10,15,font,desc,RGB(255,255,255));
		
		selector = getJoystick(pad); //Read selector position
		
		geDrawImage(475-keys[isNUMBER][0]->width, 267-keys[isNUMBER][0]->height, keys[isNUMBER][0]); //Blit back image
		
		geBlitImage(475-keys[isNUMBER][1]->width + selector.x*(keys[isNUMBER][1]->width/3), 
					267-keys[isNUMBER][1]->height+selector.y*(keys[isNUMBER][1]->height/3), 
					keys[isNUMBER][1], //Blit cropped image
					selector.x*(keys[isNUMBER][1]->width/3), selector.y*(keys[isNUMBER][1]->height/3), 
					keys[isNUMBER][1]->width/3, keys[isNUMBER][1]->height/3,true);
		
		if ((pad.Buttons &PSP_CTRL_TRIANGLE) && !(oldpad.Buttons &PSP_CTRL_TRIANGLE))
		{
			if (!strcmp(clavier[isNUMBER] [selector.y] [selector.x][0],"de"))
			{
				if (strlen(input) > 0)
					input[strlen(input)-1] = 0;
			}
			else
				strcat(input, clavier[isNUMBER] [selector.y] [selector.x][0]);
		}
		else if ((pad.Buttons &PSP_CTRL_SQUARE) && !(oldpad.Buttons &PSP_CTRL_SQUARE))
			strcat(input, clavier[isNUMBER] [selector.y] [selector.x][1]);
		
		else if ((pad.Buttons &PSP_CTRL_CROSS) && !(oldpad.Buttons &PSP_CTRL_CROSS))
			strcat(input, clavier[isNUMBER] [selector.y] [selector.x][2]);
		
		else if ((pad.Buttons &PSP_CTRL_CIRCLE) && !(oldpad.Buttons &PSP_CTRL_CIRCLE))
			strcat(input, clavier[isNUMBER] [selector.y] [selector.x][3]);

		else if ((pad.Buttons &PSP_CTRL_LTRIGGER) && !(oldpad.Buttons &PSP_CTRL_LTRIGGER))
			isNUMBER = isNUMBER == 0 ? 1 : 0;
		else if ((pad.Buttons &PSP_CTRL_START) && !(oldpad.Buttons &PSP_CTRL_START))
			done = 1;
		
		
		oldpad = pad;
		sceDisplayWaitVblankStart();
		geSwapBuffers();
	}
	
	return input;
}

void deinitDanzeff()
{
	if (!initialised) return;
	
	geFreeImage(keys[0][0]);	
	geFreeImage(keys[0][1]);
	geFreeImage(keys[1][0]);
	geFreeImage(keys[1][1]);
}

//EOF
