/*  UNDEAD TERROR
 *  functions.c
 *  
 *
 *  Created by FlavR & Leo.
 *  Copyright 2010. All rights reserved.
 *
 */


#include <stdlib.h>
#include <stdio.h>
#include <math.h>

#include <libge/libge.h>

#include "functions.h"

//Units conversion
float rad2deg(float angle)
{
	return angle * 180 / M_PI;
}

float deg2rad(float angle)
{
	return angle / 180 * M_PI;
}

//Getting the angle from 2 points
float getAngle(float x, float y, float x0, float y0)
{
	float prem = geAbs(x - x0);
	float deux = geAbs(y - y0);
	
	return rad2deg(atan(deux / prem));
}

//Delete the '\n' in a string
void supprRC(char* ligne) 
{
    char *p = strrchr(ligne, '\n');
	
    if (p != NULL)
	{
		/* If '\n' found, deleate it. */
		*p = 0;
		ligne[strlen(ligne)-1]= 0;
	}
}

//Fast fprintf
void DoLog(const char *msg, const char *path) 
{
	
	FILE *file = fopen(path, "a");
	
	if (file != NULL)
		fprintf(file, "%s\n", msg);
	
	fclose(file);
}

//Fast char/sprintf
char buffForStrPrint[2048];
char *strPrint(const char *format, ...)
{
	va_list	opt;
	
	va_start(opt, format);
	vsnprintf(buffForStrPrint, (size_t) sizeof(buffForStrPrint), format, opt);
	
	va_end(opt);
	
	return buffForStrPrint;
}

//Show magazine content(in the bottom of the screenin game)
void printMagazine(int x, int y, int total, int actual, ge_Image* Img, bool reload)
{
	int i = 1;
	actual = total - actual;
	geBlitImage(x, y, Img, 32, 0, 16, 11, 1);
	if (reload)
	{
		geBlitImage(x+6, y, Img, 65, 0, 10, 11, 1);
		geFillRectScreen(x+6+6,y, total*6, 11, RGB(31,31,31));
		geBlitImage((x+6+6+(total*6))/2+4, y, Img, 85, 0, 7, 11, 1);
		geBlitImage(x+6+total*6, y, Img, 75, 0, 10, 11, 1);
		geDrawLineScreen(x+6+6,y, x+6+total*6, y, RGB(52,52,52));
		geDrawLineScreen(x+6+6,y+10, x+6+total*6, y+10, RGB(17,17,17));
	}
	else
	{
		for (i = 1; i <= total; i++)
		{
			geBlitImage(x + 6*i, y, Img, 0, 0, 16, 11, 1);
		}	for (i = 1; i <= actual; i++)
		{
			geBlitImage(x + 6*i, y, Img, 16, 0, 16, 11, 1);
		}
	}
	geBlitImage(x + 6*(total+1), y, Img, 49, 0, 16, 11, 1);
}

//Check if object is out of screen
bool isOutOfScreen(float x, float y, float l, float h)
{
	if (x + l < 0 || x > 480 || y + h < 0 || y > 272) return true;
	
	return false;
}

//Check if collision has happened between 2 points
bool doesCollisionHappend(float x1, float y1, float l1, float h1,float x2, float y2, float l2, float h2) // 1: objet; 2: balle
{
	if ((x1 + l1 >= x2) && (y1 + h1 >= y2) && (x1 <= x2 + l2) && (y1 <= y2 + h2)) return true;
	
	return false;
}

//QTE function
bool QTE(ge_Image* imgTouches)
{
	SceCtrlData pad;
	SceCtrlData oldpad;
		sceCtrlReadBufferPositive(&oldpad, 1);
	
		int TabTouches[4] = {0x001000, 0x002000, 0x004000, 0x008000}; //PSP_CTRL_TRIANGLE  = 0x001000, PSP_CTRL_CIRCLE  = 0x002000, PSP_CTRL_CROSS  = 0x004000, PSP_CTRL_SQUARE  = 0x008000, 
		
		ge_Timer* minu = geCreateTimer("minu");
		int tour = 0;
		int padtofind;
		int x, y;
		geStartTimer(minu);
	
	while (tour < (rand() % 9) + 3)
	{
		padtofind = rand() % 4;
		x = rand() % (480 - imgTouches->width/4);
		y = rand() % (252 - imgTouches->height);
		while (1)
		{
			sceCtrlReadBufferPositive(&pad, 1);
			geClearScreen();
			geBlitImage(x, y, imgTouches,(imgTouches->width / 4) * padtofind,0, imgTouches->width / 4,imgTouches->height,1);
			geUpdateTimer(minu);
			geFillRectScreen(0,252 , (1000000 - minu->ellapsed) * 480 / 1000000, 20, RGBA(255,0,0,127));
			if (((pad.Buttons) && !(oldpad.Buttons)) || (minu->ellapsed > 1000000))
			{
				geResetTimer(minu);
				geStartTimer(minu);
				if (pad.Buttons == TabTouches[padtofind])
				{
					tour++;
					break;
				}
				else
					return false;
			}
			oldpad = pad;
			sceDisplayWaitVblankStart();
			geSwapBuffers();
		}	
		oldpad = pad;
	}
	
	return true;
}

//Show the loading animation
void printLoading(ge_Image *loadingImage, int num)
{
	int i;
	
	geDrawImage(0,0, loadingImage);
	
	for (i = 0; i < num; i++)
		geBlitImage(200 + (i*10), 145, loadingImage, 296, 185, 6, 7, true);
	
	geSwapBuffers();
}

//Reads the current level
int readNewLevel()
{
	FILE *level = fopen("Niveaux/level.txt","r");
	
	if (level == NULL)
	{
		DoLog("Error reading level.", "log.txt");
		return 1;
	}
	
	char tmp[2];
	
	fgets(tmp, 2, level);
	
	int ret = atoi(tmp);
	
	fclose(level);
	return ret;
}

//Writes the level
void writeLevel(int level)
{
	FILE *lvl = fopen("Niveaux/level.txt", "w");
	
	if (lvl == NULL)
	{
		DoLog("Error writing level.", "log.txt");
		return;
	}
	
	fprintf(lvl,"%i", level);
	
	fclose(lvl);
}

//EOF
