/*
 *  jeu.h
 *  
 *
 *  Created by FlavR & Leo on 10/08/10.
 *  Copyright 2010. All rights reserved.
 *
 */

#include <stdlib.h>
#include <stdio.h>
#include <math.h>

#include <pspaalib.h>
#include <libge/libge.h>

#include "functions.h"
#include "gui.h"
#include "scores.h"
#include "armes.h"
#include "joueur.h"
#include "zombis.h"
#include "jeu.h"

ge_Image *imgMagazine;
ge_Image *tirImage;

int jouerHistoire(ge_Font *font, ge_Image *touchesImg, Weapon wCircle[4], ImageZombi TypesZombis[4], ge_Image *Bg[10], ge_Image *cache[10])
{
	double difficulte = 1.0;
	
	switch(makeMenu(Bg[9], font, 3, "Trouble", "Hell", "Unbelievable"))
	{
		case 1: difficulte = 0.65;
		break;
		case 2: difficulte = 1;
		break;
		case 3: difficulte = 1.75;
		break;
	}
	
	int i, j;
	for( i=0; i<4; i++){
		wCircle[i].reloadTime *= difficulte;
	}
	
	
	geClearScreen();
	asm("sync\n");
	geSwapBuffers();
	
	int done;
	
	//Read current level
	int niveau = readNewLevel();
	
	do
	{		
	char cheminNiveau[25];
	sprintf(cheminNiveau, "Niveaux/%i", niveau);
	
		
	//Read Level Informations
	char infosPath[30];
	sprintf(infosPath, "%s/infos.txt", cheminNiveau);
	
	FILE *infosNivFile = fopen(infosPath, "r");
	char infosC[10];
	
	if (infosNivFile == NULL)
	{
		DoLog("Error reading level informations", "log.txt");
		return -1;
	}
	
       	fgets(infosC, 10, infosNivFile);
	
	int TypeNiveau = atoi(infosC);
	
	fgets(infosC, 10, infosNivFile);
	
	int nbTypesZombis = atoi(infosC);
	
	fgets(infosC, 10, infosNivFile);
	
	int EPAULE_X = atoi(infosC);
	
	fgets(infosC, 10, infosNivFile);
	
	int EPAULE_Y = atoi(infosC);
	
	
	fclose(infosNivFile);
	
	char niveauPrint[15];
	sprintf(niveauPrint, "Level: %i", niveau);
	
	done = 0;
	
	Joueur heros;
	heros = creerJoueur(0);

	int CurrentWeapon_n = 0;
	
	geExtendRamToDisk(true);	
	
	
	Balle tirs[70];
	
	for (i = 0; i < 70; i++)
		tirs[i].isVisible = false;
	
	//ge_Image *sang = geLoadImage("blood.png");
	
	int nbZombis = 30;
	
	for (i = 0; i < niveau; i++)
		nbZombis += 5;
	
	Zombi ennemis[30 + (niveau*5)];
	
	for (i = 0; i < nbZombis; i++)
		ennemis[i].visible = false;
	
	int ActivesZombies = 0;
	
	int Score = 0;
	char scoreTxt[20];
	
	sprintf(scoreTxt, "Score: %i / %d", Score, nbZombis);
	
	SceCtrlData pad, oldpad; //Keys definition
	sceCtrlPeekBufferPositive(&oldpad, 1);
		
	//afficherCinematique(cheminNiveau);  //STORY ISN'T FINISHED, CAANOT SHOW THAT :(
	
	geExtendRamToDisk(false);
		
	bool lectureMp3 = true, showStart = false;
		
	geClearScreen();
	
	while (done == 0)
	{
		sceCtrlPeekBufferPositive(&pad, 1); //Read pad
		
		geDrawImage(0,0, Bg[niveau - 1]);
		
		if ((pad.Buttons &PSP_CTRL_UP || pad.Ly < 56) && (heros.angleBras < 75))
			heros.angleBras++;
		else if ((pad.Buttons &PSP_CTRL_DOWN || pad.Ly > 200) && (heros.angleBras > -75))
			heros.angleBras--;
		
		if ((pad.Buttons &PSP_CTRL_SQUARE) && (heros.recharge == false) && (wCircle[CurrentWeapon_n].magazineUsedContent > 0)) heros.recharge = true;
		
		
		
		switch (wCircle[CurrentWeapon_n].type)
		{
			case 1:
				if (((oldpad.Buttons &PSP_CTRL_CROSS) && !(pad.Buttons &PSP_CTRL_CROSS)) && (heros.armeChargee == 0)) heros.armeChargee = 1;
				break;
			case 2:
				if (heros.armeChargee == 0)
					wCircle[CurrentWeapon_n].reloadSleep++;
				
				if (wCircle[CurrentWeapon_n].reloadSleep > 4)
				{
					wCircle[CurrentWeapon_n].reloadSleep = 0;
					heros.armeChargee = 1;
				}
				
				break;
			case 3:
				if (heros.armeChargee == 0)
					wCircle[CurrentWeapon_n].reloadSleep++;
				
				if (wCircle[CurrentWeapon_n].reloadSleep > 2)
				{
					wCircle[CurrentWeapon_n].reloadSleep = 0;
					heros.armeChargee = 1;
				}
				
				break;
		}
		
		
		if ((pad.Buttons &PSP_CTRL_CROSS) && (heros.armeChargee == 1) && (heros.recharge == false))
		{	
			if (AalibGetStatus(PSPAALIB_CHANNEL_WAV_1) == PSPAALIB_STATUS_STOPPED)
				AalibPlay(PSPAALIB_CHANNEL_WAV_1);
			else
				AalibRewind(PSPAALIB_CHANNEL_WAV_1);
			
			if (!( wCircle[CurrentWeapon_n].type == 3))
				tirs[wCircle[CurrentWeapon_n].magazineUsedContent] = creerTir(heros.angleBras,wCircle[CurrentWeapon_n].L, wCircle[CurrentWeapon_n].a, EPAULE_X, EPAULE_Y);
			else
				tirs[wCircle[CurrentWeapon_n].magazineUsedContent] = creerTir(heros.angleBras,wCircle[CurrentWeapon_n].L, wCircle[CurrentWeapon_n].a + rand()%3, EPAULE_X, EPAULE_Y);
			
				heros.angleBras += wCircle[CurrentWeapon_n].t; //ajout du recul
				wCircle[CurrentWeapon_n].magazineUsedContent++;
						
			heros.armeChargee = 0;
		}
		
		if (wCircle[CurrentWeapon_n].magazineUsedContent >= wCircle[CurrentWeapon_n].magazineCapacity)
			heros.recharge = true;
		
		if (heros.recharge == true)
		{
			heros.rechargement++;
			pspDebugScreenSetXY(3, 5);
			if (heros.rechargement >= wCircle[CurrentWeapon_n].reloadTime)
			{
				heros.rechargement = 0;
				wCircle[CurrentWeapon_n].magazineUsedContent = 0;
				heros.recharge = false;
			}	
		}
		
		if((pad.Buttons & PSP_CTRL_TRIANGLE) && !(oldpad.Buttons & PSP_CTRL_TRIANGLE))
		{
			CurrentWeapon_n = ChangeWeapon(CurrentWeapon_n);
			heros.recharge = false;
		}
		
		
		for (i = 0; i < wCircle[CurrentWeapon_n].magazineUsedContent; i++)
		{
			if (tirs[i].isVisible == true)
			{
				if (isOutOfScreen(tirs[i].x, tirs[i].y, tirImage->width, tirImage->height) == true) tirs[i].isVisible = false;
				
				tirs[i].x += tirs[i].avX;
				tirs[i].y -= tirs[i].avY;
				
				geDrawImageRotated(tirs[i].x, tirs[i].y, tirImage, tirs[i].angle, true);
			}
		}
		
		for (i = 0; i < nbZombis; i++)
		{
			
			if (ennemis[i].visible == true)
			{
				for (j = 0; j < wCircle[CurrentWeapon_n].magazineUsedContent; j++)
				{
					if ((tirs[j].isVisible == true) && (doesCollisionHappend(tirs[j].x, tirs[j].y, tirImage->width, tirImage->height,  ennemis[i].x, ennemis[i].y, TypesZombis[ennemis[i].type].L, TypesZombis[ennemis[i].type].H) == true))
					{
						tirs[j].isVisible = false;
						ennemis[i].vie -= wCircle[CurrentWeapon_n].damage;
						
						ennemis[i].x += 2.25;
						
						if (ennemis[i].movement == 2)
						{
							ennemis[i].y += 0.69;
							
							if (TypeNiveau == 2)
								ennemis[i].y += 0.141; 
						}
						else if (ennemis[i].movement == 3)
							ennemis[i].y -= 0.74;
					}
				}
				
				if(ennemis[i].vie <= 0)
				{
					ennemis[i].visible = false ;// On retire les ennemis morts
					ActivesZombies--;
					Score++;
					
					sprintf(scoreTxt, "Score: %i / %d", Score, nbZombis);
				}
				
				ennemis[i].sleep++;
				
				if (ennemis[i].sleep > 4)
				{
					ennemis[i].sleep = 0;
					ennemis[i].frame ++;
				}
				
				if (ennemis[i].frame >= TypesZombis[ennemis[i].type].nbSprite) ennemis[i].frame = 0;
				
				geFillRectScreen(ennemis[i].x,ennemis[i].y - 20, 32, 6, RGBA(0,0,0,150)); //Barre de sante du zombie
				geFillRectScreen(ennemis[i].x + 1,ennemis[i].y - 19, ennemis[i].vie * 30 / ennemis[i].totalVie , 4, RGBA(183,0,0,150)); //Vie restante du zombie
				
				ennemis[i].x -= 0.75;
				if (ennemis[i].movement == 2) // monte
				{
					
					if (TypeNiveau == 2) 
						ennemis[i].y -= 0.41 * 0.75;
					else 
						ennemis[i].y -= 0.75 * 0.28;//0.23219;
					
					
					if ((ennemis[i].y <= 157 - TypesZombis[ennemis[i].type].H) && (TypeNiveau == 3))
						ennemis[i].movement = 1;
				}
				else if (ennemis[i].movement == 3) // descend
				{
					ennemis[i].y += 0.75 * 0.30;//0.2458;
					if (ennemis[i].y >= 157 - TypesZombis[ennemis[i].type].H)
						ennemis[i].movement = 1;
				}
				
				geBlitImage(ennemis[i].x,ennemis[i].y, TypesZombis[ennemis[i].type].img, ennemis[i].frame * TypesZombis[ennemis[i].type].L, 0, TypesZombis[ennemis[i].type].L, TypesZombis[ennemis[i].type].H, 1);
				
				if (ennemis[i].x + TypesZombis[ennemis[i].type].L < 20)
				{
					ActivesZombies--;
					ennemis[i].visible = false;
					heros.vie -= 10;
				}
			}
			else
			{
				if ((rand() % (4000 - 2 + 1) + 1 == rand() % 4000) && (ActivesZombies < MaxActivesZombies))
				{					
					int typeTemp = rand() % nbTypesZombis;
					
					
					if (TypeNiveau == 1)
						ennemis[i] = creerZombie(typeTemp, 479, 258 - TypesZombis[typeTemp].H, 1, TypesZombis[typeTemp].vie);
					else if (TypeNiveau == 2)
						ennemis[i] = creerZombie(typeTemp, 479, 278 - TypesZombis[typeTemp].H, 2, TypesZombis[typeTemp].vie);
					else if (TypeNiveau == 3)
					{
						switch (rand() % 3)
						{
							case 0: ennemis[i] = creerZombie(typeTemp, 479, 157 - TypesZombis[typeTemp].H, 1, TypesZombis[typeTemp].vie); break;
							case 1: ennemis[i] = creerZombie(typeTemp, 479, 270 - TypesZombis[typeTemp].H, 2, TypesZombis[typeTemp].vie); break;
							case 2: ennemis[i] = creerZombie(typeTemp, 479, 38 - TypesZombis[typeTemp].H, 3, TypesZombis[typeTemp].vie); break;
						}
					}
					ActivesZombies++;
				}
			}
			
		}
		
		if (Score >= nbZombis) done = 1;
		
		if (heros.vie <= 0)
			done = 5;
		
		
		if (pad.Buttons &PSP_CTRL_START)
		{
			showStart = true;
			while (showStart)
			switch(makeMenu(Bg[niveau - 1], font, 3, "Continue", "Activate / Deactivate music", "Exit"))
			{
				case 1:
					showStart = false;
				case 2:
					if (lectureMp3 == false)
					{
						AalibPlay(PSPAALIB_CHANNEL_SCEMP3_1);
						lectureMp3 = true;
					}
					else
					{
						AalibStop(PSPAALIB_CHANNEL_SCEMP3_1);
						lectureMp3 = false;
					}
					break;
				case 3:
					showStart = false;
					done = 2;
					break;
			}
		}
		
		
		geDrawImageRotated(EPAULE_X, EPAULE_Y, wCircle[CurrentWeapon_n].img, heros.angleBras, true); //Affichage du joueur
		geDrawImage(0,0,cache[niveau-1]);
		geFillRectScreen(350,10, 102, 10, RGBA(0,0,0, 130)); //Barre de sante du heros
		geFillRectScreen(351,11,heros.vie, 8, RGBA(183,0,0, 130)); //Vie restante du heros 

		
		printMagazine(10, 260, wCircle[CurrentWeapon_n].magazineCapacity, wCircle[CurrentWeapon_n].magazineUsedContent, imgMagazine, heros.recharge);
		
		geIntraFontPrintScreen(5, 5, font, strPrint("Score: %i / %d", Score, nbZombis), RGB(255,255,255));
		geIntraFontPrintScreen(10, 235, font, wCircle[CurrentWeapon_n].name, RGB(255,128,0));
		geIntraFontPrintScreenCentered(5, font, niveauPrint, RGBA(255,255,255, 200));
		
		sceDisplayWaitVblankStart();
		geSwapBuffers();
		
		/*pspDebugScreenSetXY(0,0);
		pspDebugScreenPrintf("FPS: %i", geFps());*/
		 
		oldpad = pad;
	}
	
	for (i = 0; i < 4; i++) //Reset weapons
		wCircle[i].magazineUsedContent = 0;
	
	
	if (done == 1)
	{
	transition();
	if (QTE(touchesImg) == 0) return 1;
		
		niveau += niveau == 10 ? 0 : 1;
		writeLevel(niveau); //Write the new Level
	}
	
	if (done == 5) 
	{
		Lost(font, Bg[niveau], Score); //Show lost animation
		transition();
		done = 2;
	}
		
	} while (done != 2);
	
	return 1;
}


//###################################################### Survival! ##########################################
int jouerSurvival(ge_Font *font, Weapon wCircle[4], ImageZombi TypesZombis[4], ge_Image *Bg, ge_Image *cache, int niveau)
{
	double difficulte = 1.0;
	
	switch(makeMenu(Bg, font, 3, "Trouble", "Hell", "Unbelievable"))
	{
		case 1: difficulte = 0.65;
		break;
		case 2: difficulte = 1;
		break;
		case 3: difficulte = 1.75;
		break;
	}
	
	int i, j;
	for( i=0; i<4; i++){
		wCircle[i].reloadTime *= difficulte;
	}
	
	geClearScreen();
	asm("sync\n");
	geSwapBuffers();
	
	
	int done = 0;
	
	Joueur heros;
	heros = creerJoueur(0);
	
	char cheminNiveau[25];
	sprintf(cheminNiveau, "Niveaux/%i", niveau);
	
	char infosPath[30];
	sprintf(infosPath, "%s/infos.txt", cheminNiveau);
	
	FILE *infosNivFile = fopen(infosPath, "r");
	
	if (infosNivFile == NULL)
	{
		DoLog("Error reading level informations", "log.txt");
		return -1;
	}
	
	char infosC[10];
	
	fgets(infosC, 10, infosNivFile);
	
	int TypeNiveau = atoi(infosC);
	
	fgets(infosC, 10, infosNivFile); //Pour passer nbTypeZombis, qui est à 4 pour le Survival ;)
	
	fgets(infosC, 10, infosNivFile);
	
	int EPAULE_X = atoi(infosC);
	
	fgets(infosC, 10, infosNivFile);
	
	int EPAULE_Y = atoi(infosC);
	
	
	fclose(infosNivFile);	
	
	
	
	int CurrentWeapon_n = 0;
	
	
	//ge_Image *imgMagazine = geLoadImage("magazine.png");
	//geSwizzle(imgMagazine);

	
	
	//ge_Image *tirImage = geLoadImage("tir.png");
	//geSwizzle(tirImage);
	
	Balle *tirs;
	tirs = malloc(70 * sizeof(Balle));
	
	for (i = 0; i < 70; i++)
		tirs[i].isVisible = false;
	
	//ge_Image *sang = geLoadImage("blood.png");
	
	
	Zombi *ennemis;
	ennemis = malloc(25 * sizeof(Zombi));
	
	for (i = 0; i < 25; i++)
		ennemis[i].visible = false;
	
	int ActivesZombies = 0;
	
	int Score = 0;
	char scoreTxt[20];
	
	sprintf(scoreTxt, "Score: %i", Score);
	
	SceCtrlData pad;
	SceCtrlData oldpad;//Variable oldpad
	sceCtrlPeekBufferPositive(&oldpad, 1);
	
	while (done == 0)
	{
		geClearScreen();
		sceCtrlPeekBufferPositive(&pad, 1); //Lis les touches pour le pad
		
		geDrawImage(0,0, Bg);
		
		if ((pad.Buttons &PSP_CTRL_UP || pad.Ly < 56) && (heros.angleBras < 75))
		{
			heros.angleBras++;
		}
		else if ((pad.Buttons &PSP_CTRL_DOWN || pad.Ly > 200) && (heros.angleBras > -75))
		{
			heros.angleBras--;
		}
		
		if ((pad.Buttons &PSP_CTRL_SQUARE) && (heros.recharge == false) && (wCircle[CurrentWeapon_n].magazineUsedContent > 0)) heros.recharge = true;
		
		
		
		switch (wCircle[CurrentWeapon_n].type)
		{
			case 1:
				if (((oldpad.Buttons &PSP_CTRL_CROSS) && !(pad.Buttons &PSP_CTRL_CROSS))  && (heros.armeChargee == 0)) heros.armeChargee = 1;
				break;
			case 2:
				if (heros.armeChargee == 0)
					wCircle[CurrentWeapon_n].reloadSleep++;
				
				if (wCircle[CurrentWeapon_n].reloadSleep > 4)
				{
					wCircle[CurrentWeapon_n].reloadSleep = 0;
					heros.armeChargee = 1;
				}
				
				break;
			case 3:
				if (heros.armeChargee == 0)
					wCircle[CurrentWeapon_n].reloadSleep++;
				
				if (wCircle[CurrentWeapon_n].reloadSleep > 2)
				{
					wCircle[CurrentWeapon_n].reloadSleep = 0;
					heros.armeChargee = 1;
				}
				
				break;
		}
		
		
		if ((pad.Buttons &PSP_CTRL_CROSS) && (heros.armeChargee == 1) && (heros.recharge == false))
		{
			AalibRewind(PSPAALIB_CHANNEL_WAV_1);
			AalibPlay(PSPAALIB_CHANNEL_WAV_1);
			
			if (!( wCircle[CurrentWeapon_n].type == 3))
			{
				tirs[wCircle[CurrentWeapon_n].magazineUsedContent] = creerTir(heros.angleBras,wCircle[CurrentWeapon_n].L, wCircle[CurrentWeapon_n].a, EPAULE_X, EPAULE_Y);
			}
			else
			{
				tirs[wCircle[CurrentWeapon_n].magazineUsedContent] = creerTir(heros.angleBras,wCircle[CurrentWeapon_n].L, wCircle[CurrentWeapon_n].a + rand()%3, EPAULE_X, EPAULE_Y);
			}
			heros.angleBras += wCircle[CurrentWeapon_n].t;//ajout du recul
			wCircle[CurrentWeapon_n].magazineUsedContent++;
			
			heros.armeChargee = 0;
		}
		
		if (wCircle[CurrentWeapon_n].magazineUsedContent >= wCircle[CurrentWeapon_n].magazineCapacity)
			heros.recharge = true;
		
		if (heros.recharge == true)
		{
			heros.rechargement++;
			if (heros.rechargement >= wCircle[CurrentWeapon_n].reloadTime)
			{
				heros.rechargement = 0;
				wCircle[CurrentWeapon_n].magazineUsedContent = 0;
				heros.recharge = false;
			}	
		}
		
		if((pad.Buttons & PSP_CTRL_TRIANGLE) && !(oldpad.Buttons & PSP_CTRL_TRIANGLE))
		{
			CurrentWeapon_n = ChangeWeapon(CurrentWeapon_n);
			heros.recharge = false;
		}
		
		
		for (i = 0; i < wCircle[CurrentWeapon_n].magazineUsedContent; i++)
		{
			if (tirs[i].isVisible == true)
			{
				if (isOutOfScreen(tirs[i].x, tirs[i].y, tirImage->width, tirImage->height) == true) tirs[i].isVisible = false;
				
				tirs[i].x += tirs[i].avX;
				tirs[i].y -= tirs[i].avY;
				
				geDrawImageRotated(tirs[i].x, tirs[i].y, tirImage, tirs[i].angle, true);
			}
		}
		
		for (i = 0; i < MaxActivesZombies; i++)
		{
			
			if (ennemis[i].visible == true)
			{
				for (j = 0; j < wCircle[CurrentWeapon_n].magazineUsedContent; j++)
				{
					if ((tirs[j].isVisible == true) && (doesCollisionHappend(tirs[j].x, tirs[j].y, tirImage->width, tirImage->height,  ennemis[i].x, ennemis[i].y, TypesZombis[ennemis[i].type].L, TypesZombis[ennemis[i].type].H) == true))
					{
						tirs[j].isVisible = false;
						ennemis[i].vie -= wCircle[CurrentWeapon_n].damage;
						
						ennemis[i].x += 2.25;
						
						if (ennemis[i].movement == 2)
						{
							ennemis[i].y += 0.69;
							
							if (TypeNiveau == 2)
								ennemis[i].y += 0.141; 
						}
						else if (ennemis[i].movement == 3)
							ennemis[i].y -= 0.74;
						
						//ennemis[i].sleep = 0;
						
						//geDrawImage(ennemis[i].x - 28, ennemis[i].y + TypesZombis[ennemis[i].type].H - sang->height, sang);
					}
				}
				
				if(ennemis[i].vie <= 0)
				{
					ennemis[i].visible = false ;// On retire les ennemis morts
					ActivesZombies--;
					Score++;
					
					sprintf(scoreTxt, "Score: %i", Score);
				}
				
				ennemis[i].sleep++;
				
				if (ennemis[i].sleep > 4)
				{
					ennemis[i].sleep = 0;
					ennemis[i].frame ++;
				}
				
				if (ennemis[i].frame >= TypesZombis[ennemis[i].type].nbSprite) ennemis[i].frame = 0;
				
				geFillRectScreen(ennemis[i].x,ennemis[i].y - 20, 32, 6, RGBA(0,0,0,150)); //Barre de sante du zombie
				geFillRectScreen(ennemis[i].x + 1,ennemis[i].y - 19, ennemis[i].vie * 30 / ennemis[i].totalVie , 4, RGBA(183,0,0,150)); //Vie restante du zombie
				
				ennemis[i].x -= 0.75;
				if (ennemis[i].movement == 2) // monte
				{
					
					if (TypeNiveau == 2) 
						ennemis[i].y -= 0.41 * 0.75;//tan(deg2rad(22.91))
					else 
						ennemis[i].y -= 0.75 * 0.28;//0.23219;
					
					if ((ennemis[i].y <= 157 - TypesZombis[ennemis[i].type].H) && (TypeNiveau == 3))
						ennemis[i].movement = 1;
				}
				else if (ennemis[i].movement == 3) // descend
				{
					ennemis[i].y += 0.75 * 0.30;//0.2458;
					if (ennemis[i].y >= 157 - TypesZombis[ennemis[i].type].H)
						ennemis[i].movement = 1;
				}
				
				geBlitImage(ennemis[i].x,ennemis[i].y, TypesZombis[ennemis[i].type].img, ennemis[i].frame * TypesZombis[ennemis[i].type].L, 0, TypesZombis[ennemis[i].type].L, TypesZombis[ennemis[i].type].H, 1);
				
				if (ennemis[i].x + TypesZombis[ennemis[i].type].L < 20)
				{
					ActivesZombies--;
					ennemis[i].visible = false;
					heros.vie -= 10;
				}
			}
			else
			{
				if ((rand() % (300 - 2 + 1) + 1 == rand() % 300) && (ActivesZombies < MaxActivesZombies))
				{					
					int typeTemp = rand() % 4;
					
					
					if (TypeNiveau == 1)
						ennemis[i] = creerZombie(typeTemp, 479, 258 - TypesZombis[typeTemp].H, 1, TypesZombis[typeTemp].vie);
					else if (TypeNiveau == 2)
						ennemis[i] = creerZombie(typeTemp, 479, 278 - TypesZombis[typeTemp].H, 2, TypesZombis[typeTemp].vie);
					else if (TypeNiveau == 3)
					{
						switch (rand() % 3)
						{
							case 0: ennemis[i] = creerZombie(typeTemp, 479, 157 - TypesZombis[typeTemp].H, 1, TypesZombis[typeTemp].vie); break;
							case 1: ennemis[i] = creerZombie(typeTemp, 479, 270 - TypesZombis[typeTemp].H, 2, TypesZombis[typeTemp].vie); break;
							case 2: ennemis[i] = creerZombie(typeTemp, 479, 38 - TypesZombis[typeTemp].H, 3, TypesZombis[typeTemp].vie); break;
						}
					}
					ActivesZombies++;
				}
			}
			
		}
		
		if (heros.vie <= 0)
			done = 2;
		
		
		geDrawImageRotated(EPAULE_X, EPAULE_Y, wCircle[CurrentWeapon_n].img, heros.angleBras, true); //Affichage du joueur
		geDrawImage(0,0,cache);
		geFillRectScreen(350,10, 102, 10, RGBA(0,0,0, 130)); //Barre de sante du heros
		geFillRectScreen(351,11,heros.vie, 8, RGBA(183,0,0, 130)); //Vie restante du heros 
		
		
		printMagazine(10, 260, wCircle[CurrentWeapon_n].magazineCapacity, wCircle[CurrentWeapon_n].magazineUsedContent, imgMagazine, heros.recharge);
		
		geIntraFontPrintScreen(5, 5, font, scoreTxt, RGB(255,255,255));
		geIntraFontPrintScreen(10, 235, font, wCircle[CurrentWeapon_n].name, RGB(255,128,0));
		
		sceDisplayWaitVblankStart();
		geSwapBuffers();
		
		/*pspDebugScreenSetXY(0,0);
		pspDebugScreenPrintf("FPS: %i", geFps());*/
		
		oldpad = pad;
	}

		
	Lost(font, Bg, Score);
	
	transition();
	
	scoreS highScores[10];
	GetHighScore(highScores);
	DoLog("score loaded", "log.txt");
	if (Score > highScores[0].score)
		highScores[0] = newHighScore(Score,font, Bg);
	ListHighScore(highScores);
	WriteHighScore(highScores);

		
	transition();
	
	return 1; 
}


