/*
 *	Undead Terror  - By Lo Michel & FlavR (Flavien Raynaud) - August 2010
 *	Using Libge engine by dridri85
 *
 *  main.c
 *
 *  Copyright 2010. All rights reserved.
 *
 */


#include <stdlib.h>
#include <errno.h>

#include <pspkernel.h>
#include <psppower.h>
#include <pspdebug.h>
#include <math.h>
#include <time.h>

#include "aalib/pspaalib.h" //Audio playing
#include <libge/libge.h>

#include "functions.h" //Functions
#include "scores.h"
#include "gui.h"

#include "armes.h" //Weapons

#include "joueur.h" //Player
#include "zombis.h" //Ennemies
#include "splash.h" //Splash screen
#include "cine.h" //Cinematics

#include "jeu.h" //Game
#include "credits.h" //Credits


//Module informations
PSP_MODULE_INFO("Undead Terror", 0, 0, 1);
PSP_HEAP_SIZE_KB(2 * 1024);

ge_Image *loadingImage;

int main(int args, char** argc)
{
	pspDebugScreenInit();
	geInit();
	
	geClearColor(RGB(0,0,0));
	
	scePowerSetClockFrequency(333, 333, 166); //Overclock the PSP (useful for MP3 Playing)
	
	AalibInit();
	
	if (AalibLoad("Sounds/music.mp3", PSPAALIB_CHANNEL_SCEMP3_1, false) != 0) return -1;
	
	AalibPlay(PSPAALIB_CHANNEL_SCEMP3_1);
	
	AalibSetAutoloop(PSPAALIB_CHANNEL_SCEMP3_1, true);
	 
	srand(time(NULL));
	
		ge_Image *mainImage = geLoadImage("Images/main.png");
		geSwizzle( mainImage);
	
	loadingImage = geLoadImage("Images/chargement.png");

	showSplash(); //Splash screens animation
	
	geDrawImage(0,0, loadingImage);
	geSwapBuffers();
	
	ge_Font *intra = geLoadIntraFont("flash0:/font/ltn8.pgf");
	geIntraFontSize(intra, 13);
	geIntraFontShadowColor(intra, RGBA(0,0,0,0));
	
	ge_Image *touchesImg = geLoadImage("Images/touches.png");
	geSwizzle(touchesImg);
	
	printLoading(loadingImage, 1);
	
	Weapon wCircle[4];
	wCircle[0] = initWeapon("Pistol", "Armes/357magnum.png", 7, 1, 130, 30, 52, 5, 0.5);
	wCircle[1] = initWeapon("Uzi", "Armes/uzi.png", 25, 2, 110, 20, 59, 6,1);
	
	printLoading(loadingImage, 2);
	
	wCircle[2] = initWeapon("M16", "Armes/m16.png", 30, 2, 130, 15, 66, 6,1.25);
	wCircle[3] = initWeapon("Machinegun", "Armes/machinegun.png",70, 3, 200, 10, 66, 7,2);
	
	printLoading(loadingImage, 3);
	
	ImageZombi TypesZombis[4];
	TypesZombis[0] = creerImageZombi(geLoadImage("Ennemis/basic.png"), 12, 100);
	TypesZombis[1] = creerImageZombi(geLoadImage("Ennemis/prof.png"), 11, 130);
	
	printLoading(loadingImage, 4);
	
	TypesZombis[2] = creerImageZombi(geLoadImage("Ennemis/female.png"), 12, 160);
	TypesZombis[3] = creerImageZombi(geLoadImage("Ennemis/hardone.png"), 13, 200);
	
	int i;
	
	printLoading(loadingImage, 5);
	
	
	Back[0] = geLoadImage("Niveaux/1/Background.jpg");
	Cache[0] = geLoadImage("Niveaux/1/cache.png");
	
	printLoading(loadingImage, 6);
	
    Back[1] = geLoadImage("Niveaux/2/Background.jpg");
	Cache[1] = geLoadImage("Niveaux/2/cache.png");
	Back[2] = Back[1];
	Cache[2] = Cache[1];
	Back[3] = Back[1];
	Cache[3] = Cache[1];
	
	printLoading(loadingImage, 7);
	
	Back[4] = geLoadImage("Niveaux/5/Background.jpg");
	Cache[4] = geLoadImage("Niveaux/5/cache.png");
	Back[5] = Back[4];
	Cache[5] = Cache[4];
	Back[6] = Back[4];
	Cache[6] = Cache[4];
	
	printLoading(loadingImage, 8);
	
	Back[7] = geLoadImage("Niveaux/8/Background.jpg");
	Cache[7] = geLoadImage("Niveaux/8/Cache.png");
	Back[8] = Back[7];
	Cache[8] = Cache[7];
	Back[9] = Back[7];
	Cache[9] = Cache[7];
	
	printLoading(loadingImage, 9);
	
	
	if (AalibLoad("Sounds/tir.wav", PSPAALIB_CHANNEL_WAV_1, true) != 0) return -1;
	
	//sceKernelDeleteThread(thread[2]);
	
	lostBlood = geLoadImage("Images/death.png");
	imgMagazine = geLoadImage("Images/magazine.png");
	tirImage = geLoadImage("Images/tir.png");

	
	int play = 0, alea;
	
	while (play == 0)
	{
		switch(makeMenu(mainImage, intra, 6, strPrint("Continue Story Mode (lvl%i)", readNewLevel()), "New Story", "Play Survival Mode","ScoreBoard", "Credits", "Exit Game"))
		{
			case 1:
				//sceKernelDelayThread(200 * 1000);
				transition();
				jouerHistoire(intra, touchesImg, wCircle, TypesZombis, Back, Cache);
				break;
			case 2:
				if (1)
				{
				FILE *nouvNiveau = fopen("Niveaux/level.txt", "w");
				fprintf(nouvNiveau, "%i", 1);
				fclose(nouvNiveau);
				transition();
				jouerHistoire(intra, touchesImg, wCircle, TypesZombis, Back, Cache);
				}
				break;
			case 3:
				//sceKernelDelayThread(200 * 1000);
				transition();
				alea = fmod(rand(), 10);
				jouerSurvival(intra, wCircle, TypesZombis, Back[alea], Cache[alea], alea + 1);
				break;
			case 4:
				transition();
				scoreS highScores[10];
				GetHighScore(highScores);
				PrintHighScore(highScores, intra, mainImage);
				break;
			case 5:
				jouerCredits(intra, mainImage);
				break;
			case 6:
				play = 3;
				break;
		}
	}
	
	
	AalibUnload(PSPAALIB_CHANNEL_SCEMP3_1);
	AalibUnload(PSPAALIB_CHANNEL_WAV_1);
	
	for (i = 0; i < 10; i++)
	{
		geFreeImage(Back[i]);
		geFreeImage(Cache[i]);
	}
	
	geFreeImage(lostBlood);
	geFreeImage(loadingImage);
	
	geFreeIntraFont(intra);
	geFreeImage(touchesImg);
	geFreeImage(mainImage);
	
	//geQuit(); freeze
	sceKernelExitGame();
	
	return 1;
}

